/*
 * Unique Schlüssel für JPA Entität
 */
package de.ivu.elect.business.ergebnis.entity;
import java.util.function.Function;
import java.util.ArrayList;
import java.util.stream.Collectors;

@javax.enterprise.inject.Vetoed
public class ErgebnisUK
implements de.ivu.elect.jee.entity.tk.EntityUK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

    protected final de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart;

    public de.ivu.elect.business.ergebnis.entity.Ergebnisart getErgebnisart(){
      return ergebnisart;
    }
    protected final java.lang.String name;

    public java.lang.String getName(){
      return name;
    }

  protected final de.ivu.elect.business.wahl.entity.WahlUK wahlUK;

    public de.ivu.elect.business.wahl.entity.WahlUK getWahlUK(){
      return wahlUK;
    }

  public ErgebnisUK(
de.ivu.elect.business.ergebnis.entity.Ergebnisart ergebnisart
, java.lang.String name
,   de.ivu.elect.business.wahl.entity.WahlUK wahlUK
  ) {
    super();


      this.ergebnisart = ergebnisart;
      this.name = name;
        this.wahlUK = wahlUK;
    }

  @Override
  public int hashCode() {
        int result = 1;
    
    
                    result = result + ((ergebnisart == null) ? 0 : ergebnisart.hashCode());
                    result = result + ((name == null) ? 0 : name.hashCode());
        
                    result = result + ((wahlUK == null) ? 0 : wahlUK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    
    if (getClass() != obj.getClass()) {
      return false;
    }

            ErgebnisUK other = (ErgebnisUK) obj;

                if (ergebnisart == null) {
          if (other.ergebnisart != null) {
            return false;
          }
        } else if (!ergebnisart.equals(other.ergebnisart)) {
          return false;
        }
                if (name == null) {
          if (other.name != null) {
            return false;
          }
        } else if (!name.equals(other.name)) {
          return false;
        }
        
                if (wahlUK == null) {
          if (other.wahlUK != null) {
            return false;
          }
        } else if (!wahlUK.equals(other.wahlUK)) {
          return false;
        }
            
    return true;
  }

  @Override
  public String getEntityMessageKey() {
    return ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(wahlUK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL, ErgebnisConstants.MESSAGE_KEY_ERGEBNISART_EINZAHL, ergebnisart));
                    result.add(new de.ivu.elect.jee.entity.tk.EntityFieldValue(ErgebnisConstants.MESSAGE_KEY_ENTITY_EINZAHL, ErgebnisConstants.MESSAGE_KEY_NAME_EINZAHL, name));
        
        return result;
      }
  
    @Override
  public String toString() {
    return "ErgebnisUK[" + toStringParameter() + "]";
  }

            protected String toStringParameter() {
              String result = ""

                                                        +"ergebnisart="+ergebnisart
                            +", "                +"name="+name
                                        +", "                +"wahlUK="+wahlUK
                        ;
                          return result;
            
            }




          public String allUKFields() {
    return String.join(", ", getAllUKFieldValues().stream()
         .map(object -> (object != null ? object.toString() : null))
         .collect(Collectors.toList()));
    }

   protected ArrayList<Object> getAllUKFieldValues() {
              ArrayList<Object> list = new ArrayList<>();
              list.add(ergebnisart);
         list.add(name);
     return list;
   }

            public static <E extends Ergebnis> java.util.Map<ErgebnisUK, E> mappeErgebnisNachUK(java.util.Collection<E> entities) {

                return entities.stream().collect(java.util.stream.Collectors.toMap(Ergebnis::getErgebnisUK, Function.<E>identity(), (u,v)->v));
             }


                public static Function<Ergebnis, ErgebnisUK> getErgebnisToUKFunction() {
                return Ergebnis::getErgebnisUK;
                }

}
